require 'openssl'

module Symmetric
	class Safe

		def fill(data)
			@data = data
		end

		def close(pwd)
			cipher = OpenSSL::Cipher::AES256.new(:CBC)
			cipher.encrypt
			@iv = cipher.random_iv

			@salt = OpenSSL::Random.random_bytes 16
			@iter = 20000
			key_len = cipher.key_len
			digest = OpenSSL::Digest::SHA256.new

			key = OpenSSL::PKCS5.pbkdf2_hmac(pwd, @salt, @iter, key_len, digest)
			cipher.key = key
			@data = cipher.update(@data) + cipher.final
		end

		def open(pwd)
			decipher = OpenSSL::Cipher::AES256.new(:CBC)
			decipher.decrypt
			decipher.iv = @iv

			key_len = decipher.key_len
			digest = OpenSSL::Digest::SHA256.new

			key = OpenSSL::PKCS5.pbkdf2_hmac(pwd, @salt, @iter, key_len, digest)
			decipher.key = key
			@data = decipher.update(@data) + decipher.final
		end
	end
end
